<?php
/**
 * Kim
 *
 * PHP version 7.4
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * slis hub
 *
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.7.4
 * Contact: dev@slis.io
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.1.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Hub\Model;

use \ArrayAccess;
use \SLIS\Adapter\Hub\ObjectSerializer;

/**
 * Kim Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<string, mixed>
 */
class Kim implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'Kim';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'initialStatus' => 'string',
        'type' => 'string',
        'bestellungsposition' => 'string[]',
        'kimContractId' => 'string',
        'kimAdresse' => 'string',
        'passwort' => 'string',
        'zertifikatsnummer' => 'string',
        'children' => 'string[]',
        'uuid' => 'string',
        'id' => 'int',
        'name' => 'string',
        'position' => '\SLIS\Adapter\Hub\Model\KimPosition',
        'status' => 'string',
        'created' => '\DateTime',
        'updated' => '\DateTime'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'initialStatus' => null,
        'type' => null,
        'bestellungsposition' => null,
        'kimContractId' => null,
        'kimAdresse' => null,
        'passwort' => null,
        'zertifikatsnummer' => null,
        'children' => null,
        'uuid' => null,
        'id' => null,
        'name' => null,
        'position' => null,
        'status' => 'iri-reference',
        'created' => 'date-time',
        'updated' => 'date-time'
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static array $openAPINullables = [
        'initialStatus' => false,
		'type' => false,
		'bestellungsposition' => false,
		'kimContractId' => false,
		'kimAdresse' => false,
		'passwort' => false,
		'zertifikatsnummer' => false,
		'children' => false,
		'uuid' => false,
		'id' => false,
		'name' => false,
		'position' => true,
		'status' => false,
		'created' => true,
		'updated' => true
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected array $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of nullable properties
     *
     * @return array
     */
    protected static function openAPINullables(): array
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return boolean[]
     */
    private function getOpenAPINullablesSetToNull(): array
    {
        return $this->openAPINullablesSetToNull;
    }

    /**
     * Checks if a property is nullable
     *
     * @param string $property
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        return self::openAPINullables()[$property] ?? false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @param string $property
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        return in_array($property, $this->getOpenAPINullablesSetToNull(), true);
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'initialStatus' => 'initial_status',
        'type' => 'type',
        'bestellungsposition' => 'bestellungsposition',
        'kimContractId' => 'kimContractId',
        'kimAdresse' => 'kimAdresse',
        'passwort' => 'passwort',
        'zertifikatsnummer' => 'zertifikatsnummer',
        'children' => 'children',
        'uuid' => 'uuid',
        'id' => 'id',
        'name' => 'name',
        'position' => 'position',
        'status' => 'status',
        'created' => 'created',
        'updated' => 'updated'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'initialStatus' => 'setInitialStatus',
        'type' => 'setType',
        'bestellungsposition' => 'setBestellungsposition',
        'kimContractId' => 'setKimContractId',
        'kimAdresse' => 'setKimAdresse',
        'passwort' => 'setPasswort',
        'zertifikatsnummer' => 'setZertifikatsnummer',
        'children' => 'setChildren',
        'uuid' => 'setUuid',
        'id' => 'setId',
        'name' => 'setName',
        'position' => 'setPosition',
        'status' => 'setStatus',
        'created' => 'setCreated',
        'updated' => 'setUpdated'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'initialStatus' => 'getInitialStatus',
        'type' => 'getType',
        'bestellungsposition' => 'getBestellungsposition',
        'kimContractId' => 'getKimContractId',
        'kimAdresse' => 'getKimAdresse',
        'passwort' => 'getPasswort',
        'zertifikatsnummer' => 'getZertifikatsnummer',
        'children' => 'getChildren',
        'uuid' => 'getUuid',
        'id' => 'getId',
        'name' => 'getName',
        'position' => 'getPosition',
        'status' => 'getStatus',
        'created' => 'getCreated',
        'updated' => 'getUpdated'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('initialStatus', $data ?? [], null);
        $this->setIfExists('type', $data ?? [], 'KIM');
        $this->setIfExists('bestellungsposition', $data ?? [], null);
        $this->setIfExists('kimContractId', $data ?? [], null);
        $this->setIfExists('kimAdresse', $data ?? [], null);
        $this->setIfExists('passwort', $data ?? [], null);
        $this->setIfExists('zertifikatsnummer', $data ?? [], null);
        $this->setIfExists('children', $data ?? [], null);
        $this->setIfExists('uuid', $data ?? [], null);
        $this->setIfExists('id', $data ?? [], null);
        $this->setIfExists('name', $data ?? [], null);
        $this->setIfExists('position', $data ?? [], null);
        $this->setIfExists('status', $data ?? [], null);
        $this->setIfExists('created', $data ?? [], null);
        $this->setIfExists('updated', $data ?? [], null);
    }

    /**
    * Sets $this->container[$variableName] to the given data or to the given default Value; if $variableName
    * is nullable and its value is set to null in the $fields array, then mark it as "set to null" in the
    * $this->openAPINullablesSetToNull array
    *
    * @param string $variableName
    * @param array  $fields
    * @param mixed  $defaultValue
    */
    private function setIfExists(string $variableName, array $fields, $defaultValue): void
    {
        if (self::isNullable($variableName) && array_key_exists($variableName, $fields) && is_null($fields[$variableName])) {
            $this->openAPINullablesSetToNull[] = $variableName;
        }

        $this->container[$variableName] = $fields[$variableName] ?? $defaultValue;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets initialStatus
     *
     * @return string|null
     */
    public function getInitialStatus()
    {
        return $this->container['initialStatus'];
    }

    /**
     * Sets initialStatus
     *
     * @param string|null $initialStatus initialStatus
     *
     * @return self
     */
    public function setInitialStatus($initialStatus)
    {

        if (is_null($initialStatus)) {
            throw new \InvalidArgumentException('non-nullable initialStatus cannot be null');
        }

        $this->container['initialStatus'] = $initialStatus;

        return $this;
    }

    /**
     * Gets type
     *
     * @return string|null
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param string|null $type type
     *
     * @return self
     */
    public function setType($type)
    {

        if (is_null($type)) {
            throw new \InvalidArgumentException('non-nullable type cannot be null');
        }

        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets bestellungsposition
     *
     * @return string[]|null
     */
    public function getBestellungsposition()
    {
        return $this->container['bestellungsposition'];
    }

    /**
     * Sets bestellungsposition
     *
     * @param string[]|null $bestellungsposition bestellungsposition
     *
     * @return self
     */
    public function setBestellungsposition($bestellungsposition)
    {

        if (is_null($bestellungsposition)) {
            throw new \InvalidArgumentException('non-nullable bestellungsposition cannot be null');
        }

        $this->container['bestellungsposition'] = $bestellungsposition;

        return $this;
    }

    /**
     * Gets kimContractId
     *
     * @return string|null
     */
    public function getKimContractId()
    {
        return $this->container['kimContractId'];
    }

    /**
     * Sets kimContractId
     *
     * @param string|null $kimContractId kimContractId
     *
     * @return self
     */
    public function setKimContractId($kimContractId)
    {

        if (is_null($kimContractId)) {
            throw new \InvalidArgumentException('non-nullable kimContractId cannot be null');
        }

        $this->container['kimContractId'] = $kimContractId;

        return $this;
    }

    /**
     * Gets kimAdresse
     *
     * @return string|null
     */
    public function getKimAdresse()
    {
        return $this->container['kimAdresse'];
    }

    /**
     * Sets kimAdresse
     *
     * @param string|null $kimAdresse kimAdresse
     *
     * @return self
     */
    public function setKimAdresse($kimAdresse)
    {

        if (is_null($kimAdresse)) {
            throw new \InvalidArgumentException('non-nullable kimAdresse cannot be null');
        }

        $this->container['kimAdresse'] = $kimAdresse;

        return $this;
    }

    /**
     * Gets passwort
     *
     * @return string|null
     */
    public function getPasswort()
    {
        return $this->container['passwort'];
    }

    /**
     * Sets passwort
     *
     * @param string|null $passwort passwort
     *
     * @return self
     */
    public function setPasswort($passwort)
    {

        if (is_null($passwort)) {
            throw new \InvalidArgumentException('non-nullable passwort cannot be null');
        }

        $this->container['passwort'] = $passwort;

        return $this;
    }

    /**
     * Gets zertifikatsnummer
     *
     * @return string|null
     */
    public function getZertifikatsnummer()
    {
        return $this->container['zertifikatsnummer'];
    }

    /**
     * Sets zertifikatsnummer
     *
     * @param string|null $zertifikatsnummer zertifikatsnummer
     *
     * @return self
     */
    public function setZertifikatsnummer($zertifikatsnummer)
    {

        if (is_null($zertifikatsnummer)) {
            throw new \InvalidArgumentException('non-nullable zertifikatsnummer cannot be null');
        }

        $this->container['zertifikatsnummer'] = $zertifikatsnummer;

        return $this;
    }

    /**
     * Gets children
     *
     * @return string[]|null
     */
    public function getChildren()
    {
        return $this->container['children'];
    }

    /**
     * Sets children
     *
     * @param string[]|null $children children
     *
     * @return self
     */
    public function setChildren($children)
    {

        if (is_null($children)) {
            throw new \InvalidArgumentException('non-nullable children cannot be null');
        }

        $this->container['children'] = $children;

        return $this;
    }

    /**
     * Gets uuid
     *
     * @return string|null
     */
    public function getUuid()
    {
        return $this->container['uuid'];
    }

    /**
     * Sets uuid
     *
     * @param string|null $uuid uuid
     *
     * @return self
     */
    public function setUuid($uuid)
    {

        if (is_null($uuid)) {
            throw new \InvalidArgumentException('non-nullable uuid cannot be null');
        }

        $this->container['uuid'] = $uuid;

        return $this;
    }

    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id
     *
     * @return self
     */
    public function setId($id)
    {

        if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }

        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name name
     *
     * @return self
     */
    public function setName($name)
    {

        if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }

        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets position
     *
     * @return \SLIS\Adapter\Hub\Model\KimPosition|null
     */
    public function getPosition()
    {
        return $this->container['position'];
    }

    /**
     * Sets position
     *
     * @param \SLIS\Adapter\Hub\Model\KimPosition|null $position position
     *
     * @return self
     */
    public function setPosition($position)
    {

        if (is_null($position)) {
            array_push($this->openAPINullablesSetToNull, 'position');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('position', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['position'] = $position;

        return $this;
    }

    /**
     * Gets status
     *
     * @return string|null
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param string|null $status status
     *
     * @return self
     */
    public function setStatus($status)
    {

        if (is_null($status)) {
            throw new \InvalidArgumentException('non-nullable status cannot be null');
        }

        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets created
     *
     * @return \DateTime|null
     */
    public function getCreated()
    {
        return $this->container['created'];
    }

    /**
     * Sets created
     *
     * @param \DateTime|null $created created
     *
     * @return self
     */
    public function setCreated($created)
    {

        if (is_null($created)) {
            array_push($this->openAPINullablesSetToNull, 'created');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('created', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['created'] = $created;

        return $this;
    }

    /**
     * Gets updated
     *
     * @return \DateTime|null
     */
    public function getUpdated()
    {
        return $this->container['updated'];
    }

    /**
     * Sets updated
     *
     * @param \DateTime|null $updated updated
     *
     * @return self
     */
    public function setUpdated($updated)
    {

        if (is_null($updated)) {
            array_push($this->openAPINullablesSetToNull, 'updated');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('updated', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['updated'] = $updated;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


